table.sort( ulx.help, function (a,b) -- Sort our help
	return (a.cmd < b.cmd)
end )

table.sort( ulx.convarhelp, function (a,b) -- Sort our help
	return (a.cmd < b.cmd)
end )

-- This takes care of the things in the configs directory.

if not _file.Exists( "lua/ulx/configs/forcedownload.ini" ) then
	ULib.print( "[ULX] ERROR: The forcedownload.ini file is missing!" )
else
	local file = ULib.stripComments( _file.Read( "lua/ulx/configs/forcedownload.ini" ), "//" )
	local lines = ULib.explode( file, "\n+" )
	for _, line in pairs( lines ) do
		local data = ULib.stripQuotes( string.gsub( line, "^.*(%b\"\").*$", "%1" ) )
		if data and data ~= "" then
			ULib.forceDownload( data )
		end
	end
end

if not _file.Exists( "lua/ulx/configs/server.ini" ) then
	ULib.print( "[ULX] ERROR: The server.ini file is missing!" )
else
	ULib.execFile( "lua/ulx/configs/server.ini" )
end

if _file.Exists( "lua/ulx/configs/maps/" .. _GetCurrentMap() .. ".ini" ) then
	ULib.execFile( "lua/ulx/configs/maps/" .. _GetCurrentMap() .. ".ini" )
end