-------------
--Main Menu--
-------------
local ID_CLIENTMENU	=	1
local ID_ADMINMENU	=	2

local mainMenu

function ulx.cc_menu( userid, args )
	mainMenu:showMenu( userid )
end

local function mainMenuCallback( userid, choice, seconds )
	if choice == ULib.ID_EXIT then
		return
	elseif choice == ID_CLIENTMENU then
		ulx.cc_clientMenu( userid )
	elseif choice == ID_ADMINMENU then
		ulx.cc_adminMenu( userid )
	end
end

mainMenu = ULib.Menu:new( "ULX Main Menu", mainMenuCallback )
mainMenu:addOption( "Client Menu", ID_CLIENTMENU, ACCESS_SLAY )
mainMenu:addOption( "Admin Menu", ID_ADMINMENU, ACCESS_CVAR )

ulx.CONCOMMAND( "menu", ulx.cc_menu, "- Shows the ULX main menu", ACCESS_ALL, "!menu", false )


--------------
--Admin Menu--
--------------
function ulx.cc_adminMenu( userid, args )
	local function f() return end -- Only called on exits

	local menu = ULib.Menu:new( "ULX Admin Menu", f )
	local append = ";gm_sv_setrules"

	if _GetConVar_Bool( "sv_cheats" ) then
		menu:addRconOption( "Cheats Off", "sv_cheats 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Cheats On", "sv_cheats 1" .. append, ACCESS_CVAR )	
	end
		
	if _GetConVar_Bool( "gm_sv_playerdamage" ) then
		menu:addRconOption( "Player Damage Off", "gm_sv_playerdamage 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Player Damage On", "gm_sv_playerdamage 1" .. append, ACCESS_CVAR )
	end
	
	if _GetConVar_Bool( "gm_sv_pvpdamage" ) then
		menu:addRconOption( "PvP Damage Off", "gm_sv_pvpdamage 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "PvP Damage On", "gm_sv_pvpdamage 1" .. append, ACCESS_CVAR )	
	end		
	
	if _GetConVar_Bool( "gm_sv_teamdamage" ) then
		menu:addRconOption( "Team Damage Off", "gm_sv_teamdamage 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Team Damage On", "gm_sv_teamdamage 1" .. append, ACCESS_CVAR )	
	end			
	
	if _GetConVar_Bool( "gm_sv_allowspawning" ) then
		menu:addRconOption( "Disallow Spawning", "gm_sv_allowspawning 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow Spawning", "gm_sv_allowspawning 1" .. append, ACCESS_CVAR )	
	end
	
	if _GetConVar_Bool( "gm_sv_allowmultigun" ) then
		menu:addRconOption( "Disallow Multigun", "gm_sv_allowmultigun 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow Multigun", "gm_sv_allowmultigun 1" .. append, ACCESS_CVAR )	
	end				
	
	if _GetConVar_Bool( "gm_sv_allowphysgun" ) then
		menu:addRconOption( "Disallow Physgun", "gm_sv_allowphysgun 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow Physgun", "gm_sv_allowphysgun 1" .. append, ACCESS_CVAR )	
	end	
	
	if _GetConVar_Bool( "gm_sv_allweapons" ) then
		menu:addRconOption( "All Weapons Off", "gm_sv_allweapons 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "All Weapons On", "gm_sv_allweapons 1" .. append, ACCESS_CVAR )	
	end	
	
	if _GetConVar_Bool( "gm_sv_allowignite" ) then
		menu:addRconOption( "Disallow Ignite", "gm_sv_allowignite 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow Ignite", "gm_sv_allowignite 1" .. append, ACCESS_CVAR )	
	end	
	
	if _GetConVar_Bool( "gm_sv_noclip" ) then
		menu:addRconOption( "Disallow Noclip", "gm_sv_noclip 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow Noclip", "gm_sv_noclip 1" .. append, ACCESS_CVAR )	
	end
	
	if _GetConVar_Bool( "gm_sv_allownpc" ) then
		menu:addRconOption( "Disallow NPC Spawning", "gm_sv_allownpc 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow NPC Spawning", "gm_sv_allownpc 1" .. append, ACCESS_CVAR )	
	end	
	
	if _GetConVar_Bool( "gm_sv_allowlamps" ) then
		menu:addRconOption( "Disallow Lamps", "gm_sv_allowlamps 0" .. append, ACCESS_CVAR )	
	else
		menu:addRconOption( "Allow Lamps", "gm_sv_allowlamps 1" .. append, ACCESS_CVAR )	
	end

	menu:showMenu( userid )
end

ulx.CONCOMMAND( "adminmenu", ulx.cc_adminMenu, "- Shows the ULX admin menu", ACCESS_CVAR, "!adminmenu", false )


---------------
--Client Menu--
---------------
local user_choice 	=	{}
local ID_SLAP		=	1
local ID_SLAY		=	2
local ID_SSLAY		=	3
local ID_FREEZE		=	4
local ID_UNFREEZE	=	5
local ID_GOD		=	6
local ID_UNGOD		=	7
local ID_IGNITE		=	8
local ID_KICK		=	9
local ID_KICKBAN	=	10
local ID_TEAM_RED	=	11
local ID_TEAM_GREEN	=	12
local ID_TEAM_BLUE	=	13
local ID_TEAM_YELLOW	=	14
local ID_GIMP		=	15
local ID_UNGIMP		=	16

local function clientMenuFinal( userid, choice, seconds )
	local target = user_choice[ userid ]
	if not target or not _PlayerInfo( target, "connected" ) then -- ERROR!
		return
	end
	
	if choice == ULib.ID_EXIT then
		return
	elseif choice == ID_SLAP then
		ULib.callCmd( userid, "ulx slap " .. target )
	elseif choice == ID_SLAY then
		ULib.callCmd( userid, "ulx slay " .. target )
	elseif choice == ID_SSLAY then
		ULib.callCmd( userid, "ulx sslay " .. target )
	elseif choice == ID_GOD then
		ULib.callCmd( userid, "ulx god " .. target )
	elseif choice == ID_UNGOD then
		ULib.callCmd( userid, "ulx ungod " .. target )
	elseif choice == ID_FREEZE then
		ULib.callCmd( userid, "ulx freeze " .. target )
	elseif choice == ID_UNFREEZE then
		ULib.callCmd( userid, "ulx unfreeze " .. target )
	elseif choice == ID_IGNITE then
		ULib.callCmd( userid, "ulx ignite " .. target )
	elseif choice == ID_KICK then
		ULib.callCmd( userid, "ulx kick " .. target )
	elseif choice == ID_KICKBAN then
		ULib.callCmd( userid, "ulx kickban " .. target )
	elseif choice == ID_TEAM_RED then
		ULib.callCmd( userid, "ulx team " .. target .. " red" )
	elseif choice == ID_TEAM_GREEN then
		ULib.callCmd( userid, "ulx team " .. target .. " green" )
	elseif choice == ID_TEAM_BLUE then
		ULib.callCmd( userid, "ulx team " .. target .. " blue" )
	elseif choice == ID_TEAM_YELLOW then
		ULib.callCmd( userid, "ulx team " .. target .. " yellow" )
	elseif choice == ID_GIMP then
		ULib.callCmd( userid, "ulx gimp " .. target )
	elseif choice == ID_UNGIMP then
		ULib.callCmd( userid, "ulx ungimp " .. target )
	end
		
end

local function clientMenuCallback( userid, target, seconds )
	if target == ULib.ID_EXIT then
		return
	end
	
	user_choice[ userid ] = target
	local menu = ULib.Menu:new( "ULX Command", clientMenuFinal )
	menu:addOption( "Slap Player", ID_SLAP, ACCESS_SLAY )
	menu:addOption( "Slay Player", ID_SLAY, ACCESS_SLAY )
	menu:addOption( "SSlay Player", ID_SSLAY, ACCESS_SLAY )
	menu:addOption( "Kick Player", ID_KICK, ACCESS_KICK )
	menu:addOption( "Kickban Player", ID_KICKBAN, ACCESS_BAN )		
	menu:addOption( "Give Godmode", ID_GOD, ACCESS_SLAY )
	menu:addOption( "Remove Godmode", ID_UNGOD, ACCESS_SLAY )				
	menu:addOption( "Freeze Player", ID_FREEZE, ACCESS_KICK )
	menu:addOption( "Unfreeze Player", ID_UNFREEZE, ACCESS_KICK )
	menu:addOption( "Ignite Player", ID_IGNITE, ACCESS_SLAY )
	menu:addOption( "Force Team Red", ID_TEAM_RED, ACCESS_PLAYER )
	menu:addOption( "Force Team Blue", ID_TEAM_BLUE, ACCESS_PLAYER )
	menu:addOption( "Force Team Green", ID_TEAM_GREEN, ACCESS_PLAYER )
	menu:addOption( "Force Team Yellow", ID_TEAM_YELLOW, ACCESS_PLAYER )
	menu:addOption( "Gimp", ID_GIMP, ACCESS_SLAY )
	menu:addOption( "Ungimp", ID_UNGIMP, ACCESS_SLAY )						
	menu:showMenu( userid )
end

function ulx.cc_clientMenu( userid, args )
	local menu = ULib.Menu:new( "Choose a Player", clientMenuCallback )
	menu:addPlayerOptions()
	menu:showMenu( userid )
end

ulx.CONCOMMAND( "clientmenu", ulx.cc_clientMenu, "- Shows the client admin menu", ACCESS_SLAY, "!clientmenu", false )

-------------
--Maps Menu--
-------------

local maps = ULib.filesInDir( "maps" )
c = 1
while c <= table.getn( maps ) do -- We need a while loop so it keeps evaluating the condition
	if string.sub( maps[ c ], -4 ) == ".bsp" then
		maps[ c ] = string.sub( maps[ c ], 1, -5 )
		c = c + 1
	else
		table.remove( maps, c )
	end
end
c = nil

function ulx.sendMapMenu( userid )
	if not ulx.ucl.query( userid, ACCESS_MAP ) then
		return
	end

	for i=1, table.getn( maps ) do
		_spawnmenu.AddItem( userid, "Changelevel", "+" .. maps[ i ], "ulx map " .. maps[ i ] )
	end
end

ulx.ucl:addAccessCallback( ulx.sendMapMenu )


----------------
--Cleanup Menu--
----------------
function ulx.sendCleanupMenu( userid )
	if not ulx.ucl.query( userid, ACCESS_ENT ) then
		return
	end

	_spawnmenu.AddItem( userid, "Misc ULX", "+Clean Ragdolls", "ulx cleanragdolls" )
	_spawnmenu.AddItem( userid, "Misc ULX", "+Clean Flames", "ulx cleanflames" )
	_spawnmenu.AddItem( userid, "Misc ULX", "+Clean Props", "ulx cleanprops" )
	_spawnmenu.AddItem( userid, "Misc ULX", "+Clean Sprites", "ulx cleansprites" )
	_spawnmenu.AddItem( userid, "Misc ULX", "+Clean Vehicles", "ulx cleanvehicles" )
	_spawnmenu.AddItem( userid, "Misc ULX", "+Clean NPCs", "ulx cleannpcs" )
end

ulx.ucl:addAccessCallback( ulx.sendCleanupMenu )